#ifndef QPMain_h
#define QPMain_h

#include <QMainWindow>
#include "ui_qp.h"

class QPrinter;
class QPrintDialog;
class QFileDialog;
class QLabel;
class QComboBox;

class QPMain : public QMainWindow {

   Q_OBJECT

public:

   QPMain();

   virtual
   ~QPMain();

   bool
   LoadConfigFile(QString config_name);

   bool
   LoadImageFile(QString image_name);

   void
   SetBatchMode();

public slots:

   void
   BatchPrint();

   void
   printSetup();

   void
   print();

   void
   saveConfig();

   void
   loadConfig();

   void
   loadImage();

   void
   changeScale(int scale_index);

   void
   doViewChange();

   void
   doShowErrors();

   void
   doAbout();

   void
   showHomePage();

private:

   void
   InternLoadConfig(QString config_name);

   void
   SetActionSensitivity();

   void
   SetViewSize();

   QFileDialog *
   ConfigFileDialog();

   QFileDialog *
   SaveConfigDialog();

   QFileDialog *
   LoadConfigDialog();

   void
   ShowErrors(QString msg);

   Ui::MainWindow ui;

   QPrinter * printer;

   QPrintDialog * printDialog;

   QFileDialog * fileDialog;

   QPixmap * image;

   QLabel * scale_label;
   QComboBox * scale_combo;

   double scale_factor;

   bool batch_mode;

   QString msg_accum;
};

#endif // QPMain_h
